% script for solve_ftmp_sticky_matrix 

   %        x                  pi                    ui      us     v     q 
   A = [(1+sigma*kappa/bet) sigma*(thet_ipi-1/bet)  sigma   0      0      0; %x
         -kappa/bet         1/bet                   0       0      0      0; %pi
         0                  0                       rhoi    0      0      0; %ui
         0                  0                       0       rhos   0      0; %us
         kappa/bet          thet_ipi-1/bet          1      -rhos   1      0; %v
         0                  thet_ipi/omeg           1/omeg  0      0      1/omeg]; %q
    
    [Q L] = eig(A);  % Q*L*inv(Q) = A
    
    B = [sigma ; % x here B is the loading on the deterministic variable 
        0 ; %pi
        0; %ui
        0; %us
        1; %v 
        1/omeg]; %q
                
        C = [0 0; % x  loading on epsilons
             0 0;  % pi
             1 0;  % ui
             0 1;  % us 
             0 -1;  % v
             0 0];  % q
        
        D = [ 1 0 0 ; % x loading on deltas x, pi, q
              0 1 0 ;   % pi 
              0 0 0 ;   %ui 
              0 0 0 ;   % us
              0 -1 omeg ;   % v 
              0 0 1 ];    % q 
          

    if thet_ipi > 1; % treat surplus as an expectational shock
        disp('Likely error, thet_ipi > 1 case not reviewed') 
        D = [D C(:,2)];
        C = C(:,1);
        shock = shock(1);
    end

%reorder with eigenvalues in increasing order

l = diag(L); 
[ls,indx] = sort(l); 
Ls = diag(ls); 
Qs = Q(:,indx); 
QsI = inv(Qs); 

Q = Qs;
L = Ls;
QI = QsI; 
l = ls; 

clear Qs Ls QsI ls;

%display

format bank
if 1
    disp('eigenvalues')
    disp(l')
    
    disp('Q, Q^-1')
    disp(Q);
    disp(QI);
end

% create impulse response function

% yt = Q*zt yt = lam yt-1 + shock t


if 1; % new, BCD notation, extends to expected vishock, scalable code
    
    indx_gt_1 = find(abs(l)>=1);
    indx_lt_1 = find(abs(l)<1); 
    N_gt_1 = size(indx_gt_1,1);
    N_lt_1 = size(indx_lt_1,1);
    if ~(size(D,2) == N_gt_1); 
        disp('error: explosive eigenvalues not equal to number of deltas')
    end;
    
    deltatil = -QI*D*inv(QI(indx_gt_1,:)*D)*QI(indx_gt_1,:)*C*shock;
    
    ut = viknown*B'*QI'; 
    
    yt = zeros(T,N_lt_1+N_gt_1);
    yt(2,indx_lt_1) =  deltatil(indx_lt_1)'+ut(1,indx_lt_1)+(QI(indx_lt_1,:)*C*shock)';
    for t = 3:T;
        yt(t,indx_lt_1) = (diag(l(indx_lt_1))*yt(t-1,indx_lt_1)'+ut(t-1,indx_lt_1)')';
    end;
    
    for t = 1:T
        for j = indx_gt_1(1):indx_gt_1(end); 
            yt(t,j) = -sum((l(j).^(-(1:T-t+1)')).*ut(t:T,j));
        end;
    end;
    
    zt = yt*Q'; % transform to original variables
end;



xt = zt(:,1);
pit = zt(:,2); 
uit = zt(:,3); 
st = zt(:,4); 
vt = zt(:,5);
qt = zt(:,6); 
it = thet_ipi*pit + uit + viknown; 
rt = it(1:T-1) - pit(2:T); % expected return
if max(max(viknown))==0; % if time 1 is an unexpected shock
    rt(1) = 0;
end
rt = [rt; NaN];

rnt = omeg*qt - [0;qt(1:end-1)]; 
vt2 = 0*vt;
for tim = 2:size(vt,1);
    vt2(tim) = vt2(tim-1) + rnt(tim) - pit(tim) - st(tim);
end;
