% step_on_rake_JC_revision.m

% Makes 
    % Figure 5.15 p. 181 
    % Figure 5.10 top panel p. 174 
    % Figure 5.10 bottom panel p. 174
    % Figure 5.14 p. 181 

% These programs are copied from the steppng on a rake directory
% 5/28/18 to allow local modification. They use the notation 
% in stepping on a rake -- at some point they should use the 
% Notation of the book. 

%NOTE the new program f_solve in ctime_programs_new gives the same results.
%MOve the graphs over to that one and publish it for the book. 
% this suggestion is not implemeted -- this is the program that makes the
% graph
%
% replicates sims' stepping on a rake model
% this script sets up many different cases . 
% you can just use test_function and f_step_on_rake for one use

% NOTE all programs use sims notation, not paper notation. Changing 
% seemed likely to introduce bugs. 
% paper / programs (sims)
% i is r
% phi_pi is theta
% phi_c is phi
% r is is rho
% i is r 
% y is a 
% rho is bet 
% s is tau
% kappa is delta
% z is y

close all
clear all
T = 100; %15; % length of simulations
dt = 0.01;
printfigs = 1; % print figures? Will overwrite eps files 

font_size = 16;
gray1 = [ 0 0 0 ] + 0.5; 
allplots = 0; 
bw_plots = 1; 

% which cases to do -- zero lets you work on one case
sims = 1; % do sims parameters
case_2 = 1; % no Taylor rule zero  psi
case_3 = 0; % no taylor rule backwards phillips 
shortdebt = 0; % do both sims and case 2 with short term debt--not used in final book 
less_sticky = 1; % look at less price stickiness. 

% ---------------------
% Replicate sims
% --------------------

if sims;
    gam = 0.2;
    thet = 0.5*gam; % original 0.4
    %phi = [1.5 0]'*gam;% now loading on xdot then loading on x. Original is [0.75 0]
    phi = [0 0.5]'*gam;
    % normal phi = sims phi / gamma. Thus keep theta < gamma, say!  
    sig = 2.0;
    rhobar = 0.05;
    rhohat = 0.05; % In ms programs, set to zero to replicate sims typo. No longer implemented, 
    taubar = 0.10;
    bet = 0.10;
    delt = 0.20;
    omeg = 1;% now loading on xdot then loading on x; original is [1 0]
    psi = 2;
    longdebt = 1;
    em = 0.001;
    etau = 0; % etau = -0.001 replicates sims fig 4 exactly
    
      [eigs,t,rt, pit,at, taut,bt,lamt,ct,cdott,pt,rhot,Bt,...
        ta,rta, pita,ata, tauta,bta,lamta,cta,cdotta,pta,rhota,Bta] =...
        f_step_on_rake_revision(gam,thet,phi,sig,rhobar,rhohat,taubar,bet,delt,omeg,psi,...
        longdebt,T,dt,em,etau);
    if 0
        script_sims_figure_revision; %script to make sims figure as exactly as possible
        
        if printfigs ;
            set(gcf, 'PaperPosition', [0.25 2.5 6.0 8.0]);
            % print sims figure
            print -depsc2 sims_fig_3.eps
            savefig ('sims_fig_3');
        end;
    end;

       % Figure 5.14 p. 181 
    
    script_sims_rates_graph_revision; % makes my graph of all rates for sims case
    if bw_plots;
        text(2.5,0.6,'Nominal rate i','color','k','fontsize',font_size)
        text(3,-0.1,'Inflation \pi','color','k','fontsize',font_size)
        text(4,-0.38,'Output x','color',gray1,'fontsize',font_size);
    else;
        text(2.5,0.6,'Nominal rate i','color','b','fontsize',font_size)
        text(3,-0.1,'Inflation \pi','color','r','fontsize',font_size)
        text(4,-0.38,'Output x','color','k','fontsize',font_size);
    end
    axis([-1 10 -0.65 1.05]); 
    if printfigs;
        print -depsc2 sims_r.eps
        savefig('sims_r');
    end;

    % script_sims_other_graph; % makes my graph of other quantities. 
    
    %expected rate rise. Not used in Book. 
    
    script_sims_rates_expected_graph_revision; %makes graph of rates when shock expected
    box on
    if bw_plots;
        text(-0.2,0.6,'Nominal rate i','color','k','horizontalalignment','r','fontsize',font_size)
        text(2,0.4,'Inflation \pi','color','k','fontsize',font_size)
    else;
        text(-0.2,0.6,'Nominal rate i','color','b','horizontalalignment','r','fontsize',font_size)
        text(2,0.4,'Inflation \pi','color','r','fontsize',font_size)
    end;

    axis([-10 10 -inf inf]);

    if printfigs;
        print -depsc2 sims_r_expected.eps
        savefig('sims_r_expected')
    end;

    % Figure 5.15 p. 181 
    em = 0.00;
    etau = 0.001; % etau = -0.001 replicates sims fig 4 exactly
    
      [eigs,t,rt, pit,at, taut,bt,lamt,ct,cdott,pt,rhot,Bt,...
        ta,rta, pita,ata, tauta,bta,lamta,cta,cdotta,pta,rhota,Bta] =...
        f_step_on_rake_revision(gam,thet,phi,sig,rhobar,rhohat,taubar,bet,delt,omeg,psi,...
        longdebt,T,dt,em,etau);
    script_sims_rates_graph_revision; % makes my graph of all rates for sims case
    axis([-1 10 -0.8 0.05]);   
    if bw_plots;
        text(3,-0.22,'Nominal rate i','color','k','fontsize',font_size)
        text(6,-0.5,'Inflation \pi','color','k','fontsize',font_size)
        text(8,-0.23,'Output x','color',gray1,'fontsize',font_size)
    else;
        text(3,-0.22,'Nominal rate i','color','b','fontsize',font_size)
        text(6,-0.5,'Inflation \pi','color','r','fontsize',font_size)
        text(8,-0.23,'Output x','color','k','fontsize',font_size)
    end;
    box on
    if printfigs
        print -depsc2 fiscal_sims.eps
    end
    
end;

  
% -------------------------------
% no habits, taylor rule, or fiscal policy
% ------------------------------
 
if case_2;
    
    gam = 0; % persistence  of i
    thet = 0; % phi pi
    phi = 0; % phi x 
    sig = 2; %2.0 in original;
    rhobar = 0.05; % r 
    rhohat = 0.05; % set to zero to replicate sims typo
    taubar = 0.10; % surplus levelb = taubar / r  
    bet =  0.05; %0.10; in original % Phllips curve discount rate 
    delt =  0.20; % was 0.20; % price stickiness kappa
    omeg = 0; % s = omega * cdot 
    psi = 0; % Note: I have verified that very small psi produces the same result
    longdebt = 1;
    em = 0.001; % money shock. 
    etau = 0; % surplus shock
    
    [eigs,t,rt, pit,at, taut,bt,lamt,ct,cdott,pt,rhot,Bt,...
        ta,rta, pita,ata, tauta,bta,lamta,cta,cdotta,pta,rhota,Bta] =...
        f_step_on_rake_revision(gam,thet,phi,sig,rhobar,rhohat,taubar,bet,delt,omeg,psi,...
        longdebt,T,dt,em,etau);
    
    %script_sims_figure; %script to make sims figure as exactly as possible
    
    % Figure 5.10 top panel p. 174 
    
    script_sims_rates_graph_revision; % makes my graph of all rates for sims case
    box on;
    if bw_plots;
        text(1,0.5,'Nominal rate i','color','k','fontsize',font_size)
        text(1.3,-4,'Inflation \pi','color','k','fontsize',font_size)
        text(2.3,-6.2,'Output x','color',gray1,'fontsize',font_size)
    else;
        text(1,0.5,'Nominal rate i','color','b','fontsize',font_size)
        text(1.3,-4,'Inflation \pi','color','r','fontsize',font_size)
        text(3,-6,'Output x','color','k','fontsize',font_size)
    end;
    
    axis([-1 20 -inf inf]);
         
     if printfigs;
         if bet > 0;
             axis([-1 10 -inf 1.5]);
         end
        print -depsc2 case_2_r.eps
        savefig('case_2_r')   
    end;
   
  % Expected rate rise. Not used in final book. 
    
    script_sims_rates_expected_graph_revision; %makes graph of rates when shock expected
    text(-0.5,0.8,'Nominal rate i','color','b','horizontalalignment','r','fontsize',font_size)
    text(2,0.5,'Inflation \pi','color','r','fontsize',font_size)
    text(4,-0.2,'Output x','color','k','fontsize',font_size);
  axis([-10 20 -inf inf]);    
    if printfigs;
        if bet > 0; 
        axis([-10 10 -0.7 1.1]);
        end
        print -depsc2 case_2_r_expected.eps
        savefig('case_2_r_expected')
    end;
       % script_sims_other_graph; % makes my graph of other quantities. 

       
   % fiscal shock Not used in final book
     
    em = 0.00; % money shock. 
    etau = -0.001; % surplus shock
    
    [eigs,t,rt, pit,at, taut,bt,lamt,ct,cdott,pt,rhot,Bt,...
        ta,rta, pita,ata, tauta,bta,lamta,cta,cdotta,pta,rhota,Bta] =...
        f_step_on_rake_revision(gam,thet,phi,sig,rhobar,rhohat,taubar,bet,delt,omeg,psi,...
        longdebt,T,dt,em,etau);
    
    %script_sims_figure; %script to make sims figure as exactly as possible
    
    script_sims_rates_graph_revision; % makes my graph of all rates for sims case
    text(0.1,-0.5,'Nominal rate i','color','b','fontsize',font_size)
    text(1,1,'Inflation \pi','color','r','fontsize',font_size)
    text(3,3,'Output x','color','k','fontsize',font_size)
    axis([-1 20 -inf inf]); 
    
    if printfigs;
        if bet > 0
            axis([-1 10 -1 6]); 
        end
        print -depsc2 case_2_r_fiscal.eps
        savefig('case_2_r_fiscal')
        
    end;
       
end;


% -------------------------
% backward phillips curve
% ---------------------------

if case_3; % Not used in final book draft. 
    gam = 0; % persistence  of i
    thet = 0; % phi pi
    phi = 0; % phi x 
    sig = 2; %2.0 in original;
    rhobar = 0.05; % r 
    rhohat = 0.05; % set to zero to replicate sims typo
    taubar = 0.10; % surplus levelb = taubar / r  
    bet = -0.50; %0.10; in original % Phllips curve discount rate 
    delt = -0.10; % was 0.20; % price stickiness kappa
    omeg = 0; % s = omega * cdot 
    psi = 0; % Note: I have verified that very small psi produces the same result
    longdebt = 1;
    em = 0.001; % money shock. 
    etau = 0; % surplus shock
    
    [eigs,t,rt, pit,at, taut,bt,lamt,ct,cdott,pt,rhot,Bt,...
        ta,rta, pita,ata, tauta,bta,lamta,cta,cdotta,pta,rhota,Bta] =...
        f_step_on_rake_revision(gam,thet,phi,sig,rhobar,rhohat,taubar,bet,delt,omeg,psi,...
        longdebt,T,dt,em,etau);
    
    %script_sims_figure; %script to make sims figure as exactly as possible
    
    script_sims_rates_graph_revision; % makes my graph of all rates for sims case
    text(1,0.5,'Nominal rate i','color','b','fontsize',font_size)
    text(1.3,-4,'Inflation \pi','color','r','fontsize',font_size)
    text(3,-6,'Output x','color','k','fontsize',font_size)
     axis([-1 40 -inf inf]);
         
     if printfigs;
        print -depsc2 case_3_r.eps
        savefig('case_3_r')   
    end;
   
    
    script_sims_rates_expected_graph_revision; %makes graph of rates when shock expected
    text(-0.5,0.8,'Nominal rate i','color','b','horizontalalignment','r','fontsize',font_size)
    text(2,0.5,'Inflation \pi','color','r','fontsize',font_size)
    text(4,-0.2,'Output x','color','k','fontsize',font_size);  
        axis([-10 40 -inf inf]);
    if printfigs;
        print -depsc2 case_3_r_expected.eps
        savefig('case_3_r_expected')
    end;
       % script_sims_other_graph; % makes my graph of other quantities. 
    
     % fiscal shock
    em = 0.00; % money shock. 
    etau = 0.001; % surplus shock
    
    [eigs,t,rt, pit,at, taut,bt,lamt,ct,cdott,pt,rhot,Bt,...
        ta,rta, pita,ata, tauta,bta,lamta,cta,cdotta,pta,rhota,Bta] =...
        f_step_on_rake_revision(gam,thet,phi,sig,rhobar,rhohat,taubar,bet,delt,omeg,psi,...
        longdebt,T,dt,em,etau);
    
    %script_sims_figure; %script to make sims figure as exactly as possible
    
    script_sims_rates_graph_revision; % makes my graph of all rates for sims case
    text(0.1,0.5,'Nominal rate i','color','b','fontsize',font_size)
    text(1,-1,'Inflation \pi','color','r','fontsize',font_size)
    text(3,-3,'Output x','color','k','fontsize',font_size)
    axis([-1 40 -inf inf]); 
    
    if printfigs;
        print -depsc2 case_3_r_fiscal.eps
        savefig('case_3_r_fiscal')
        
    end;
end  
       


% ----------------------
% short term debt
% ----------------------

% not used in final book draft 

if shortdebt;
    % first sims with short debt
    gam = 0.5;
    thet = 0.4;
    phi = 0.75;
    sig = 2.0;
    rhobar = 0.05;
    rhohat = 0.05; % set to zero to replicate sims typo
    taubar = 0.10;
    bet = 0.10;
    delt = 0.20;
    omeg = 1;
    psi = 2;
    longdebt = 0; % this is the only difference from above. 
    em = 0.001;
    etau = 0; % etau = -0.001 replicates sims fig 4 exactly
    
    [eigs,t,rt, pit,at, taut,bt,lamt,ct,cdott,pt,rhot,Bt,...
        ta,rta, pita,ata, tauta,bta,lamta,cta,cdotta,pta,rhota,Bta] =...
        f_step_on_rake_revision(gam,thet,phi,sig,rhobar,rhohat,taubar,bet,delt,omeg,psi,...
        longdebt,T,dt,em,etau);
    
    script_sims_rates_graph_revision; % makes my graph of all rates for sims case
    text(1,0.8,'Nominal rate i','color',colorvec(1,:),'fontsize',font_size)
    text(1,0.2,'Inflation \pi','color',colorvec(2,:),'fontsize',font_size)
    axis([-1 10 -0.2 1.03]); 
     
    if printfigs;
        print -depsc2 sims_r_short.eps
        savefig('sims_r_short');
    end;
        
    script_sims_rates_expected_graph_revision; %makes graph of rates when shock expected
    text(-0.2,0.8,'Nominal rate i','color',colorvec(1,:),'horizontalalignment','r','fontsize',font_size)
    text(2,0.3,'Inflation \pi','color',colorvec(2,:),'fontsize',font_size)
     axis([-10 10 -0.1 1.2]);
   
    if printfigs;
        print -depsc2 sims_r_short_expected.eps
        savefig('sims_r_short_expected')
    end;
    %

    % no habits, taylor rule, or fiscal policy with short debt 
 
    gam = 0;
    thet = 0;
    phi = 0;
    sig = 2.0;
    rhobar = 0.05;
    rhohat = 0.05; % set to zero to replicate sims typo
    taubar = 0.10;
    bet = 0.10;
    delt = 0.20;
    omeg = 0;
    psi = 0;
    longdebt = 0; % this is the only difference from case_2 above 
    em = 0.001;
    etau = 0;
    
    [eigs,t,rt, pit,at, taut,bt,lamt,ct,cdott,pt,rhot,Bt,...
        ta,rta, pita,ata, tauta,bta,lamta,cta,cdotta,pta,rhota,Bta] =...
        f_step_on_rake_revision(gam,thet,phi,sig,rhobar,rhohat,taubar,bet,delt,omeg,psi,...
        longdebt,T,dt,em,etau);
    
    
    script_sims_rates_graph_revision; % makes my graph of all rates for sims case
    text(1,0.95,'Nominal rate i','color',colorvec(1,:),'fontsize',font_size)
    text(1,1.05,'Inflation \pi','color',colorvec(2,:),'fontsize',font_size)
    axis([-1 10 -0.1 1.1]); 
   
    if printfigs;
        print -depsc case_2_r_shortdebt.eps
        savefig('case_2_r_shortdebt')
    end;
    
 
    script_sims_rates_expected_graph_revision; %makes graph of rates when shock expected
     text(-0.2,0.8,'Nominal rate i','color',colorvec(1,:),'horizontalalignment','r','fontsize',font_size)
    text(2,0.5,'Inflation \pi','color',colorvec(2,:),'fontsize',font_size)
     axis([-10 10 -0.1 1.1]);
   
    if printfigs;
        print -depsc2 case_2_r_expected_shortdebt.eps
        savefig('case_2_r_expected_shortdebt')
    end;

end;


% ----------------------
% less sticky
% ----------------------

if less_sticky;
    deltv = [0.20  1  100 0.02 0.001];
    em = 0.001;
    etau = 0;
      
    for indx = 1:size(deltv,2); 
       [eigs,t,rt, pit,at, taut,bt,lamt,ct,cdott,pt,rhot,Bt,...
        ta,rta, pita,ata, tauta,bta,lamta,cta,cdotta,pta,rhota,Bta] =...
        f_step_on_rake_revision(gam,thet,phi,sig,rhobar,rhohat,taubar,bet,deltv(indx),omeg,psi,...
        longdebt,T,dt,em,etau);
       pitv(:,indx) = pit; 
       ptv(:,indx) = pt; 
    end;
    
   
    % Figure 5.10 bottom panel p. 174
    figure;
    hold on
    box on;
    if bw_plots;
        plot([-1; 0; t], [[0;0]*ones(1,size(ptv,2)); [ptv]]/em,'-k','linewidth',2);
        plot([-1; 0; t], [0;0; rt/em],'--k','linewidth',2);
        %plot(t(1:1/dt:end),[rt(1:1/dt:end)]/em,'v','color','k','linewidth',2);
        plot([-1; 0; t(1:1/dt:end)], [0;0;ptv(1:1/dt:end,1)]/em, 'ok','linewidth',2);
        %plot(t(1:1/dt:end),[pit(1:1/dt:end)]/em,'o','color',colorvec(4,:),'linewidth',2);
        plot(t,0*t,'-k');
        text(-0.3,1,'i','color','k','horizontalalignment','right','fontsize',font_size);
        text(5-1,ptv((5-1)/dt,1)/em+1,['\kappa = ' num2str(deltv(1),'%4.2f')],'color','k',...
            'horizontalalignment','left','fontsize',font_size);
        text(5-2.4,ptv((5-2.4)/dt,2)/em+1,['\kappa = ' num2str(deltv(2),'%4.0f')],'color','k',...
            'horizontalalignment','left','fontsize',font_size);
        % text(5-3,ptv((5-3)/dt,3)/em,['\kappa =' num2str(deltv(3),'%4.0f')],'color',colorvec(3+1,:),...
        %         'horizontalalignment','left','fontsize',font_size,'backgroundcolor','w');
        text(0.5,ptv((0.5)/dt,3)/em-1,['\kappa = ' num2str(deltv(3),'%4.0f')],'color','k',...
            'horizontalalignment','left','fontsize',font_size);
        text(6,ptv((6)/dt,4)/em+1,['\kappa = ' num2str(deltv(4),'%4.3f')],'color','k',...
            'horizontalalignment','left','fontsize',font_size);
        text(7,ptv((7)/dt,5)/em-0.5,['\kappa = ' num2str(deltv(5),'%4.3f')],'color','k',...
            'horizontalalignment','left','verticalalignment','top','fontsize',font_size);
    else;
        plot([-1; 0; t], [[0;0]*ones(1,size(ptv,2)+1); [rt ptv]]/em,'linewidth',2);
        colorvec = get(gcf,'defaultaxescolororder');
        plot(t(1:1/dt:end),[rt(1:1/dt:end)]/em,'v','color',colorvec(1,:),'linewidth',2);
        plot([-1; 0; t(1:1/dt:end)], [0;0;ptv(1:1/dt:end,1)]/em, 'o','linewidth',2);
        %plot(t(1:1/dt:end),[pit(1:1/dt:end)]/em,'o','color',colorvec(4,:),'linewidth',2);
        plot(t,0*t,'-k');
        text(-0.3,1,'i','color',colorvec(1,:),'horizontalalignment','right','fontsize',font_size);
        text(5-1,ptv((5-1)/dt,1)/em+1,['\kappa =' num2str(deltv(1),'%4.2f')],'color',colorvec(1+1,:),...
            'horizontalalignment','left','fontsize',font_size,'backgroundcolor','w');
        text(5-2,ptv((5-2)/dt,2)/em+1,['\kappa =' num2str(deltv(2),'%4.0f')],'color',colorvec(2+1,:),...
            'horizontalalignment','left','fontsize',font_size,'backgroundcolor','w');
        % text(5-3,ptv((5-3)/dt,3)/em,['\kappa =' num2str(deltv(3),'%4.0f')],'color',colorvec(3+1,:),...
        %         'horizontalalignment','left','fontsize',font_size,'backgroundcolor','w');
        text(1.25,ptv((0.5)/dt,3)/em-1,['\kappa =' num2str(deltv(3),'%4.0f')],'color',colorvec(3+1,:),...
            'horizontalalignment','left','fontsize',font_size,'backgroundcolor','w');
        text(7,ptv((7)/dt,4)/em+1,['\kappa =' num2str(deltv(4),'%4.3f')],'color',colorvec(4+1,:),...
            'horizontalalignment','left','fontsize',font_size,'backgroundcolor','w');
        text(8,ptv((8)/dt,5)/em-1,['\kappa =' num2str(deltv(5),'%4.3f')],'color',colorvec(5+1,:),...
            'horizontalalignment','left','verticalalignment','top','fontsize',font_size,'backgroundcolor','w');
    end
        
   ylabel('Percent');     
   xlabel('Time');
    
    %for indx = 1:size(ptv,2);
    %    text(4-indx+1,ptv((4-indx+1)/dt,indx)/em,['\kappa =' num2str(deltv(indx),'%4.0f')],'color',colorvec(indx+1,:),...
    %        'horizontalalignment','left','fontsize',font_size,'backgroundcolor','w');
    %end;
    axis([-1 10 -22 2]);
    
    if printfigs;
        print -depsc2 less_sticky_price.eps
        savefig('less_sticky_price');
    end;
   
stop; 
% below here an experiment not worked out. 
   
    % *************** 
    % less sticky in the full sims model 
    % ***************
    
    if sims
        
        gam = 0.5;
        thet = 0.4;
        phi = 0.75;
        sig = 2.0;
        rhobar = 0.05;
        rhohat = 0.05; % set to zero to replicate sims typo
        taubar = 0.10;
        bet = 0.10;
        deltv = [0.2 200 2 0.05];
        omeg = 1;
        psi = 2;
        longdebt = 1;
        em = 0.001;
        etau = 0;
        
        clear pitv ptv
        
        for indx = 1:size(deltv,2);
            [eigs,t,rt, pit,at, taut,bt,lamt,ct,cdott,pt,rhot,Bt,...
                ta,rta, pita,ata, tauta,bta,lamta,cta,cdotta,pta,rhota,Bta] =...
                f_step_on_rake_revision(gam,thet,phi,sig,rhobar,rhohat,taubar,bet,deltv(indx),omeg,psi,...
                longdebt,T,dt,em,etau);
            pitv(:,indx) = pit;
            ptv(:,indx) = pt;
            disp('');
            disp('delta'); disp(deltv(indx));
            disp('eigenvalues'); disp(eigs');
            disp('number positive'); disp(sum(real(eigs)>0));
        end;
        
        
        figure;
        plot([-1;0;t],[[0;0]*ones(1,size(pitv,2)); pitv]/em, 'linewidth',2);
        hold on
        plot([-1;0;t],[0;0; rt ]/em,'linewidth',2);
        colorvec = get(gcf,'defaultaxescolororder');
        plot(t(1:1/dt:end),[rt(1:1/dt:end)]/em,'v','color',colorvec(1,:),'linewidth',2);
        %plot(t(1:1/dt:end),[pit(1:1/dt:end)]/em,'o','color',colorvec(4,:),'linewidth',2);
        plot(t,0*t,'-k');
        ylabel('%');
        % text(-0.2,1,'i','color',colorvec(1,:),'horizontalalignment','right','fontsize',font_size);
        % for indx = 1:size(pitv,2);
        %     text(-.2,pitv(1,indx)/em,['\kappa =' num2str(deltv(indx),1)],'color',colorvec(indx+1,:),...
        %         'horizontalalignment','right','fontsize',font_size,'backgroundcolor','w');
        % end;
        % axis([-1 5 -inf 2]);
        
        if printfigs;
            print -depsc2 less_sticky_inflation_full.eps
            savefig('less_sticky_inflation_full');
        end;
        
        figure;
        plot([-1; 0; t], [[0;0]*ones(1,size(ptv,2)+1); [rt ptv]]/em,'linewidth',2);
        hold on
        colorvec = get(gcf,'defaultaxescolororder');
        plot(t(1:1/dt:end),[rt(1:1/dt:end)]/em,'v','color',colorvec(1,:),'linewidth',2);
        plot([-1; 0; t(1:1/dt:end)], [0;0;ptv(1:1/dt:end,1)]/em, 'o','linewidth',2);
        %plot(t(1:1/dt:end),[pit(1:1/dt:end)]/em,'o','color',colorvec(4,:),'linewidth',2);
        plot(t,0*t,'-k');
        ylabel('Percent');
        text(2.5,0.5,'i_t','color',colorvec(1,:),'fontsize',font_size);
        text(7,-0.7, 'p_t, \kappa = 0.05, 0.2, 2, 200','color',colorvec(2,:), 'fontsize',font_size);
        xlabel('Time');
        
        axis([-1 30 -inf 1.1]);
        
        if printfigs;
            print -depsc2 less_sticky_price_full.eps
            savefig('less_sticky_price_full')
        end;
        
    end
    
end;


 